<template>
  <div>
    <AppNavbar>
      <template #buttons-between>
        <Settings />
        <AppDccUpload :dcc-is-loaded="dccIsLoaded" />
      </template>
    </AppNavbar>
    <v-main>
      <div style="min-height: 78vh">
        <v-row class="mt-3 px-2 mx-0" justify="center">
          <v-col cols="auto" class="px-2">
            <div style="position: sticky; top: 64px">
              <v-stepper
                v-model="stepper"
                non-linear
                vertical
                flat
                style="border: 1px solid lightgrey; border-radius: 5px"
              >
                <v-tooltip
                  v-for="(step, index) in steps"
                  :key="step.i18n"
                  left
                  :disabled="$vuetify.breakpoint.lgAndUp"
                >
                  <template #activator="{ on, attrs }">
                    <div v-bind="attrs" v-on="on">
                      <v-stepper-step
                        editable
                        :step="index + 1"
                        :rules="step.rules"
                        :class="{ 'no-label': $vuetify.breakpoint.mdAndDown }"
                      >
                        <span v-if="$vuetify.breakpoint.lgAndUp">
                          {{ $t(step.i18n) }}
                        </span>
                      </v-stepper-step>
                    </div>
                    <v-divider
                      v-if="index !== 0 && index < steps.length"
                      vertical
                    ></v-divider>
                  </template>
                  <span>{{ $t(step.i18n) }}</span>
                </v-tooltip>
              </v-stepper>
              <div class="mt-4">
                <LanguagePicker mobile card no-padding />
              </div>
            </div>
          </v-col>
          <v-col style="max-width: 1280px" class="px-2">
            <v-stepper v-model="stepper" non-linear style="box-shadow: none">
              <v-stepper-items>
                <v-stepper-content
                  v-for="(step, index) in steps"
                  :key="step.name"
                  :step="index + 1"
                  :class="{ 'pa-0': step.noPadding }"
                >
                  <GTab no-padding :valid.sync="validationStates[step.name]">
                    <component
                      :is="step.component"
                      v-model="steps[index].model"
                      :i18n="step.i18n"
                      :is-valid-dcc="isValidDCC"
                      v-on="step.listeners"
                      @save="saveDCC"
                      @savePDF="savePDF"
                    />
                  </GTab>
                </v-stepper-content>
              </v-stepper-items>
            </v-stepper>
          </v-col>
        </v-row>
        <StepperBottomNav
          v-model="stepper"
          :max="steps.length"
          style="box-shadow: none"
        />
      </div>

      <v-dialog v-model="sanityCheckFailedDialog" persistent max-width="850">
        <v-card>
          <v-card-title>
            {{ $t("tool.sanityCheckFailedDialog.title") }}
          </v-card-title>
          <v-card-text>
            <v-alert icon="warning" color="warning">
              {{ $t("tool.sanityCheckFailedDialog.warningText") }}
            </v-alert>
            <v-btn
              href="https://gitlab.com/ptb/dcc/gemimeg-tool/-/issues/new?issue"
              target="_blank"
              color="primary"
            >
              <v-icon left>open_in_new</v-icon>
              {{ $t("tool.sanityCheckFailedDialog.gitlabBtn") }}
            </v-btn>
            <GTextArea
              v-model="sanityCheckErrors"
              i18n="tool.sanityCheckFailedDialog.errors"
              readonly
            />
          </v-card-text>
          <v-card-actions>
            <v-btn color="red darken-1" text @click="discardXml">
              {{ $t("tool.sanityCheckFailedDialog.discardXml") }}
            </v-btn>
            <v-spacer />
            <v-btn color="green darken-1" text @click="rescueXml">
              {{ $t("tool.sanityCheckFailedDialog.rescueXml") }}
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="oldXmlDialog" persistent max-width="550">
        <v-card>
          <v-card-title class="text-h5">
            {{ $t("tool.oldXmlDialog.title") }}
          </v-card-title>
          <v-card-text>
            {{ $t("tool.oldXmlDialog.text") }}
          </v-card-text>
          <v-card-actions>
            <v-btn color="red darken-1" text @click="removeOldXml">
              {{ $t("tool.oldXmlDialog.removeXml") }}
            </v-btn>
            <v-spacer />
            <v-btn color="green darken-1" text @click="saveOldXml">
              {{ $t("tool.oldXmlDialog.saveXml") }}
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-main>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
// import Comments from "../DCC/Comments";
import { downloadFile, saveFile } from "assets/util/general";
import { ByteDataType, DCCDocument } from "@d-ptb/dcc-js";
import { PDFDocument, StandardFonts } from "pdf-lib";
import GeneralInformation from "../DCC/GeneralInformation";
import ItemList from "../DCC/AdministrativeData/ItemList";
import StatementListExtensive from "../DCC/StatementListExtensive";
import MeasurementResults from "../DCC/MeasurementResults";
import AppDccUpload from "./AppDccUpload";
import AppNavbar from "./AppNavbar";
import StepperBottomNav from "./Navigation/StepperBottomNav";
import LanguagePicker from "./LanguagePicker";
import GTab from "./Common/GTab";
import DccPreview from "./DccPreview";
import { createEmptyDcc } from "~/assets/util/dccUtil";
import { supportedSchemaVersions } from "~/assets/util/constants";
import GTextArea from "~/components/App/Form/gTextArea";
import { humanReadableCSS } from "~/assets/humanReadable.xml";
import Settings from "~/components/App/Settings.vue";
import Imprint from "~/components/App/Imprint.vue";
import About from "~/components/App/About.vue";
import GIconBtn from "~/components/App/Common/GIconBtn.vue";

export default {
  components: {
    GIconBtn,
    About,
    Imprint,
    Settings,
    GTextArea,
    GTab,
    LanguagePicker,
    StepperBottomNav,
    AppDccUpload,
    AppNavbar,
  },
  data() {
    this.loadEmptyDcc();

    return {
      newFileName: "",
      dccIsLoaded: false,
      openedFile: null,
      sanityCheckFailedDialog: false,
      sanityCheckErrors: "",
      oldXmlDialog: false,
      oldXmlContext: null,
      stepper: 1,
      validationStates: {
        generalInformation: true,
        items: true,
        statements: true,
        measurementResults: true,
        comments: true,
      },
      errors: {},
    };
  },
  computed: {
    isValidDCC() {
      return Object.values(this.validationStates).every((x) => x);
    },
    steps() {
      return [
        {
          name: "generalInformation",
          i18n: "tool.navigation.step.administrativeData",
          component: GeneralInformation,
          model:
            this.$global.dccDocument.digitalCalibrationCertificate
              .administrativeData,
          rules: [() => this.validationStates.generalInformation],
        },
        {
          name: "items",
          i18n: "tool.navigation.step.items",
          component: ItemList,
          model:
            this.$global.dccDocument.digitalCalibrationCertificate
              .administrativeData.items,
          rules: [() => this.validationStates.items],
        },
        {
          name: "statements",
          i18n: "tool.navigation.step.statements",
          component: StatementListExtensive,
          model:
            this.$global.dccDocument.digitalCalibrationCertificate
              .administrativeData.statements,
          rules: [() => this.validationStates.statements],
        },
        {
          name: "measurementResults",
          i18n: "tool.navigation.step.measurementResults",
          component: MeasurementResults,
          model:
            this.$global.dccDocument.digitalCalibrationCertificate
              .measurementResults,
          rules: [() => this.validationStates.measurementResults],
        },
        /* {
          name: "comments",
          i18n: "tool.navigation.step.comments",
          component: Comments,
          model: this.$global.dccDocument.digitalCalibrationCertificate,
          rules: [() => this.validationStates.comments],
        }, */
        {
          name: "preview",
          i18n: "tool.navigation.step.preview",
          component: DccPreview,
          listeners: {
            updateHR: async (isAttached) => {
              if (isAttached) {
                await this.updateHR();
              } else {
                this.$delete(
                  this.$global.dccDocument.digitalCalibrationCertificate,
                  "document"
                );
              }
              this.$global.updatePreview(
                DCCDocument.fromXml(this.$global.dccDocument.toXML())
              );
            },
          },
        },
      ];
    },
    previewStepIndex() {
      return this.steps.indexOf(this.steps.find((x) => x.name === "preview"));
    },
  },
  watch: {
    stepper(val) {
      // scroll to top on tab change
      this.$vuetify.goTo(0);
      if (val === this.previewStepIndex + 1) {
        this.updatePreview();
      }
    },
    "$global.hasUnsavedChanges"() {
      this.updateTitle();
    },
  },
  created() {
    this.$tool.on("dccLoaded", this.onDccLoaded);
    this.$tool.on("afterDccLoaded", this.updateTitle);
    this.$tool.on("afterDccSave", this.updateTitle);
    this.$tool.on("save", this.onSave);
    this.$tool.on("saveAs", this.onSaveAs);
    window.addEventListener("beforeunload", this.beforeunload);
    this.$global.$on("beforeUploadDialogShow", this.beforeUploadDialogShow);

    // Removes the beforeunload handler to not interrupt HMR
    if (process.env.NODE_ENV !== "production" && module.hot) {
      const statusHandler = (status) => {
        if (status === "prepare") {
          window.removeEventListener("beforeunload", this.beforeunload);
        }
      };
      module.hot.addStatusHandler(statusHandler);
      const disposeHandler = () => {
        module.hot.removeStatusHandler(statusHandler);
        module.hot.removeDisposeHandler(disposeHandler);
      };
      module.hot.addDisposeHandler(disposeHandler);
    }
  },
  beforeDestroy() {
    this.$tool.off("dccLoaded", this.onDccLoaded);
    this.$tool.off("afterDccLoaded", this.updateTitle);
    this.$tool.off("afterDccSave", this.updateTitle);
    this.$tool.off("save", this.onSave);
    this.$tool.off("saveAs", this.onSaveAs);
    window.removeEventListener("beforeunload", this.beforeunload);
    this.$global.$off("beforeUploadDialogShow", this.beforeUploadDialogShow);
  },
  mounted() {
    this.$tool.emit("loaded");
  },
  methods: {
    beforeunload(e) {
      if (this.dccIsLoaded && this.$global.hasUnsavedChanges) {
        e.returnValue = this.$t("tool.unsavedChangesWarning");
      }
    },
    beforeRouteLeave() {
      if (this.dccIsLoaded && this.$global.hasUnsavedChanges) {
        // return false to cancel the navigation if the user wants to stay on the page
        return confirm(this.$t("tool.unsavedChangesWarning"));
      }
      this.performAutoSave();
      this.dccIsLoaded = false;
      return true;
    },
    updateTitle() {
      let parts = [];
      if (this.openedFile) {
        parts.push(this.openedFile.filePath);
      } else {
        parts.push(this.newFileName);
      }
      if (this.$global.hasUnsavedChanges) {
        parts.push("*");
      }
      parts = [parts.join("")];
      parts.push("GEMIMEG-Tool");
      document.title = parts.join(" - ");
    },
    async onSave() {
      if (!this.dccIsLoaded) return;
      await this.saveDCC();
    },
    async onSavePDF() {
      if (!this.dccIsLoaded) return;
      await this.savePDF();
    },
    async onSaveAs() {
      if (!this.dccIsLoaded) return;
      this.$global.savingDcc = true;
      const xml = this.$global.dccDocument.toXML();
      // the dcc has to be valid and a file needs to be opened
      if (!(await this.validateDCC(xml)) || !this.openedFile) {
        this.$global.savingDcc = false;
        return;
      }
      let file;
      try {
        file = await this.$tool.storageStrategy.promptSaveAs(
          this.openedFile,
          xml
        );
      } catch (e) {
        this.$notifier.error(e);
      }
      // the returned file needs to be the new opened file
      if (file) {
        this.openedFile = file;
        await this.$tool.storageStrategy.addLastLoadedItem(this.openedFile);
        this.$tool.emit("afterDccLoaded", this.openedFile);
      }
      this.$global.savingDcc = false;
    },
    async performAutoSave() {
      if (!this.dccIsLoaded) return;
      this.$logger.info("Auto-Saving DCC to Storage.");
      // TODO: check for stability
      const xml = this.$global.dccDocument.toXML();
      let file = null;
      if (this.openedFile) {
        file = this.openedFile;
      } else {
        // create new file object if it has not been saved yet
        file = {
          fileName: this.newFileName,
          xml,
          dateTime: new Date().toISOString(),
          autoSave: true,
        };
      }
      try {
        await this.$tool.storageStrategy.performAutoSave(file, xml);
      } catch (e) {
        this.$notifier.error(e);
      }
    },
    loadEmptyDcc() {
      this.$global.loadingDcc = true;
      this.$global.dccDocument = createEmptyDcc();
      this.$global.loadingDcc = false;
    },
    async onDccLoaded(context) {
      this.stepper = 1;

      const { newFileName, file, dccDocument } = context;
      if (this.dccIsLoaded) {
        if (!confirm(this.$t("tool.overrideWarning"))) {
          this.$global.loadingDcc = false;
          return;
        }
      }
      if (
        !supportedSchemaVersions.includes(
          dccDocument.digitalCalibrationCertificate._attr.schemaVersion
        )
      ) {
        this.$logger.warn("Old XML detected.");
        this.oldXmlDialog = true;
        this.oldXmlContext = context;
        this.$global.loadingDcc = false;
        return;
      }

      this.openedFile = file;
      this.newFileName = newFileName;
      // TODO: remove and use openedFile instead
      this.dccIsLoaded = true;

      // check if a file was loaded, otherwise a new file was created
      if (this.openedFile) {
        // add the opened file to the last loaded files
        await this.$tool.storageStrategy.addLastLoadedItem(this.openedFile);
      }

      // set current language to first mandatory language
      this.setCurrentUsedLangISO639(
        dccDocument.digitalCalibrationCertificate.administrativeData.coreData
          .mandatoryLangCodeISO639_1.length
          ? dccDocument.digitalCalibrationCertificate.administrativeData
              .coreData.mandatoryLangCodeISO639_1[0]._text
          : "en"
      );
      this.$global.dccDocument = dccDocument;

      // await the next tick so the watchers for dccDocument are handled
      await this.$nextTick();
      this.$notifier.success(this.$t("tool.upload.loaded"));
      this.$global.loadingDcc = false;
      this.$global.hasUnsavedChanges = false;
      this.$tool.emit("afterDccLoaded", {
        ...this.openedFile,
        name: newFileName,
      });
    },
    beforeUploadDialogShow() {
      if (this.dccIsLoaded) {
        this.performAutoSave();
      }
    },
    async validateDCC(xml) {
      this.$logger.info("DCC XML", xml);
      this.$logger.info("DCC Document", this.$global.dccDocument);

      if (!this.isValidDCC) {
        this.$logger.info("Tool says DCC is invalid.");
        this.$notifier.error(this.$t("tool.invalidDccWarning"));
        return false;
      }
      this.$logger.success("Tool says DCC is valid.");

      // do not validate if file size exceeds 4MB
      if (new Blob([xml]).size > 4000000) {
        this.$notifier.info(this.$t("tool.noAttachmentValidationWarning"));
      }

      this.$logger.info("Running Sanity Check with xmllint.");

      const result = await this.$tool.validationStrategy.validate(xml);

      if (!result.valid) {
        // Show user that sanity check fails -> with option to save regardless
        this.$logger.fatal("Sanity Check failed.", result);
        this.$logger.fatal("XML", xml);
        this.showFailedDCC(result.errors);
        return false;
      }
      return true;
    },
    async savePDF() {
      const xml = this.$global.dccDocument.toXML();
      if (!(await this.validateDCC(xml))) {
        return;
      }
      const xmlFileName = this.newFileName || this.openedFile.filePath;
      // Create a new PDFDocument instance
      const pdfDoc = await PDFDocument.create();
      // Add a new page to the PDF document
      const page = pdfDoc.addPage();
      // Add some text to the page
      const font = await pdfDoc.embedFont(StandardFonts.Helvetica);
      const fontSize = 18;
      const lines = [
        "This PDF file contains an xml DCC as an attachment.",
        "The xml file can be extracted using any PDF reader, which",
        "allows access to attachments, e.g. Mozilla Firefox,",
        "Adobe Acrobat Reader or Foxit PDF Reader.",
      ];
      // Choose width of the longest line as textWidth
      const textWidth = font.widthOfTextAtSize(lines[1], fontSize);
      const textHeight = font.heightAtSize(fontSize);

      lines.forEach((line, index) => {
        page.drawText(line, {
          x: (page.getWidth() - textWidth) / 2,
          y: page.getHeight() - (index + 1) * textHeight * 2 - 50,
          size: fontSize,
          font,
        });
      });
      // Embed the XML data as a data URI
      // btoa says characters outside Latin1 range
      // workaround from https://stackoverflow.com/questions/23223718/failed-to-execute-btoa-on-window-the-string-to-be-encoded-contains-characte
      const b64xml = unescape(encodeURIComponent(xml));
      const xmlDataUri = `data:application/xml;base64,${btoa(b64xml)}`;
      // Embed the XML file as an attachment
      await pdfDoc.attach(xmlDataUri, xmlFileName, {
        mimeType: "application/xml",
        description: "Digital Calibration Certificate",
        creationDate: new Date(),
        modificationDate: new Date(),
      });
      // Save the PDF as a file
      const pdfBytes = await pdfDoc.save();
      const pdfBlob = new Blob([pdfBytes], { type: "application/pdf" });
      const pdfUrl = URL.createObjectURL(pdfBlob);
      downloadFile(pdfUrl, xmlFileName.replace(".xml", ".pdf"));
    },
    async saveDCC() {
      this.$global.savingDcc = true;
      this.$tool.emit("beforeDccSave", this.$global.dccDocument);

      const xml = this.$global.dccDocument.toXML();

      if (!(await this.validateDCC(xml))) {
        this.$global.savingDcc = false;
        return;
      }

      this.$logger.success("Sanity Check passed. Saving DCC.");
      if (this.openedFile) {
        try {
          await this.openedFile.save(xml);
        } catch (e) {
          this.$notifier.error(e);
          this.$global.savingDcc = false;
          return;
        }
      } else {
        // the new file is saved and stays open, we need to save the reference to it
        let file;
        try {
          file = await this.$tool.storageStrategy.saveNewItem(
            this.newFileName,
            xml
          );
        } catch (e) {
          this.$notifier.error(e);
        }
        // file is null if the user cancelled the save or something went wrong
        if (!file) {
          this.$global.savingDcc = false;
          return;
        }
        this.openedFile = file;
      }

      this.$notifier.success(this.$t("tool.savedDcc"));
      this.$global.hasUnsavedChanges = false;
      this.$global.savingDcc = false;
      this.$tool.emit("afterDccSave", this.openedFile);
    },
    rescueXml() {
      this.saveXml(this.$global.dccDocument.toXML());
      this.sanityCheckFailedDialog = false;
    },
    discardXml() {
      this.dccIsLoaded = true;
      this.loadEmptyDcc();
      this.sanityCheckFailedDialog = false;
      this.stepper = 1;
    },
    showFailedDCC(errors) {
      this.sanityCheckFailedDialog = true;
      this.sanityCheckErrors = errors.map((x) => x.toString()).join("\n");
    },
    saveXml(xml, fileName = "dcc.xml") {
      saveFile(fileName, xml, "application/xml");
    },
    async updateHR() {
      let result = await this.$tool.previewStrategy.renderPreview(
        this.$global.dccDocument
      );
      // embed css styles in html
      result = result.replace(
        `<link rel="stylesheet" href="xslt-dcc/dcc.css">`,
        "<style>" + humanReadableCSS + "</style>"
      );
      const b64hr = Buffer.from(result).toString("base64");

      const byteData = new ByteDataType();
      byteData.fileName._text = "human_readable.html";
      byteData.mimeType._text = "text/html";
      byteData.dataBase64._text = b64hr;

      this.$set(
        this.$global.dccDocument.digitalCalibrationCertificate,
        "document",
        byteData
      );
    },
    updatePreview() {
      if (this.isValidDCC) {
        // update human-readable html if it was generated by the tool
        if (
          this.$global.dccDocument.digitalCalibrationCertificate.document
            ?.fileName._text === "human_readable.html"
        ) {
          this.updateHR();
        }
        this.$global.updatePreview(
          DCCDocument.fromXml(this.$global.dccDocument.toXML())
        );
      }
    },
    removeOldXml() {
      this.$tool.storageStrategy.removeLastLoadedItem(this.oldXmlContext.file);
      this.dccIsLoaded = true;
      this.loadEmptyDcc();
      this.oldXmlDialog = false;
      this.stepper = 1;
    },
    saveOldXml() {
      this.saveXml(this.oldXmlContext.dccDocument.toXML());
      this.dccIsLoaded = true;
      this.loadEmptyDcc();
      this.oldXmlDialog = false;
      this.stepper = 1;
    },
    ...mapMutations(["setCurrentUsedLangISO639"]),
  },
};
</script>

<style lang="scss">
.v-stepper {
  padding: 0;

  .v-stepper__content {
    padding-top: 0 !important;
  }

  &.v-stepper--vertical {
    .v-stepper__step {
      padding: 24px !important;

      &.no-label {
        .v-stepper__step__step {
          margin-right: 0 !important;
        }
      }
    }

    .v-divider {
      margin: -8px -36px -16px 36px;
      height: 45px;
    }
  }
}
</style>
